# serves as the key in list.sort() function
# for sorting of list based on second element of its the item
def returnSecond(value):
    return value[1]

###############################################
# na vstupu ocekava retezec, smaze vsechny nevhodne znaky
# a zbytek prevede na upper case (kvuli pismenum na zacatku vety, atd.)
# slouzi k preprocessingu pred vyhledavani jednotlivych slov
###############################################
def preprocess(value):
    value = value.translate({ord(c): None for c in ',."()?!-'})
    value = value.upper()
    return value

###############################################
# na vstupu ocekava setrideny seznam 'my_list',
# zatridi do nej prvek 'item'
###############################################
def insort(my_list, item):
    # v tomto pripade se rovnou pripoji 'item'
    if my_list == [] or my_list[len(my_list)-1][1] <= item[1]:
        my_list.append(item)
        return
    x = 0
        # nalezeni pozice 'x' v seznamu, na kterou
        # se bude vkladat 'item'
    while my_list[x][1] < item[1]:
        x += 1
    my_list.append(0)   # slouzi pouze k prodlouzeni seznamu
        # odsunuti vsech prvku vetsich nez 'item' doprava
    for y in range(len(my_list)-1,x,-1):
        my_list[y] = my_list[y-1]
    my_list[x] = item

###############################################
# na vstupu ocekava setrideny seznam 'my_list',
# zatridi do nej prvek 'item'
# nejmensi prvek zahodi
###############################################
def insort_replace(my_list, item):
    if my_list[0][1] >= item[1]:  # v tom pripade se rovnou zahodi 'item'
        return
    x = 0
    # nalezeni pozice 'x' v seznamu, na kterou
    # se bude vkladat 'item'
    while x < len(my_list) and my_list[x][1] < item[1]:
        x += 1
    x-=1
    # odsunuti vsech prvku mensich nez 'item' doleva
    # nejmensi prvek bude zahozen
    for y in range(x):
        my_list[y] = my_list[y+1]
    my_list[x] = item

###############################################
# returns list of 10 biggest elements of the 'input_list'
###############################################
def get10(input_list):
     my_list = input_list[:] # kopirujeme vstup, abychom ho nemodifikovali
     result = []
        # naplnime result 10ti prvky. Pokud je vstup
        # kratsi, naplnime result 'len(my_list)' prvky
     for x in range(min(len(my_list),10)):
         insort(result, my_list.pop())
     if x < 9: return result    # the list is shorter than 10
        # postupne pridavame dalsi prvky a vzdy zahodime nejmensi
     for x in my_list:
         insort_replace(result, x)
     return result



def most_freq_words(filename):
    file_handle = open(filename,"r")
    word_count = dict()
        #cist soubor po radcich
    for line in file_handle.readlines():
            # prevest na uppercase, odstranit interpunkci
        line = preprocess(line)
            # rozdelit radek na seznam slov
        word_list = line.split()
        for word in word_list:
             if len(word) >= 3:
                 # zvysit count existujiciho slova, resp.
                 # pridat novy prvek s hodnotou 1
                 word_count[word] = word_count.get(word,0) + 1
    file_handle.close()
    results = list(word_count.items())
#    results.sort(reverse=True, key=returnSecond) # kratky zapis, ale slozitost nlog n az n^2
    results = get10(results)    # vlastni implementace se slozitosti ~10n
    for i in range(10):
        print(results[i])


most_freq_words('sherlock-holmes.txt')